unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Outlook2000, adxolFormsManager, StdCtrls, Grids;

type
  TadxOlForm1 = class(TadxOlForm)
    btnStart: TButton;
    btnStop: TButton;
    StringGrid1: TStringGrid;
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure adxOlFormDestroy(Sender: TObject);
  private
    { Private declarations }
    FThread: Pointer;
    procedure AddRow;
    procedure StopThread;
    procedure DoTerminate(Sender: TObject);
  protected
    { Protected declarations }
    procedure WndProc(var Message: TMessage); override;
  public
    { Public declarations }
  published
    { Published declarations }
  end;

{NOTE: The adxOlForm1 variable is intended for the exclusive use
       by the TadxOlFormsCollectionItem Designer.
       NEVER use this variable for other purposes.}
var
  adxOlForm1 : TadxOlForm1;

implementation

uses SyncObjs;

{$R *.DFM}

type
  TMyThread = class(TThread)
  private
    FHandle: HWND;
  protected
    procedure Execute; override;
  public
    constructor Create(AHandle: HWND);
  end;

{ TMyThread }

constructor TMyThread.Create(AHandle: HWND);
begin
  FHandle := AHandle;
  FreeOnTerminate := False;
  inherited Create(True);
end;

procedure TMyThread.Execute;
var
  i: Integer;
begin
  for i := 0 to 100 do begin
    if IsWindow(FHandle) then
      PostMessage(FHandle, WM_USER + 2500, 0, 0);
    Sleep(1000);
    if Terminated then Exit;
  end;
end;

{ TadxOlForm1 }

procedure TadxOlForm1.btnStartClick(Sender: TObject);
begin
  StringGrid1.RowCount := 1;
  StringGrid1.Cells[0, 0] := '';
  StringGrid1.Cells[1, 0] := '';
  StringGrid1.Cells[2, 0] := '';

  btnStart.Enabled := False;
  FThread := TMyThread.Create(Self.Handle);
  TMyThread(FThread).Resume();
  TMyThread(FThread).OnTerminate := DoTerminate;
end;

procedure TadxOlForm1.btnStopClick(Sender: TObject);
begin
  StopThread();
end;

procedure TadxOlForm1.adxOlFormDestroy(Sender: TObject);
begin
  StopThread();
end;

procedure TadxOlForm1.StopThread();
begin
  if Assigned(FThread) then begin
    TMyThread(FThread).Terminate();
    TMyThread(FThread).WaitFor();
    TMyThread(FThread).Free();
    FThread := nil;
  end;
end;

procedure TadxOlForm1.DoTerminate(Sender: TObject);
begin
  btnStart.Enabled := True;
end;

procedure TadxOlForm1.AddRow;
begin
  StringGrid1.Cells[0, StringGrid1.RowCount - 1] := 'Record #' + IntToStr(StringGrid1.RowCount);
  StringGrid1.Cells[1, StringGrid1.RowCount - 1] := DateTimeToStr(Now);
  StringGrid1.Cells[2, StringGrid1.RowCount - 1] := 'Test';
  StringGrid1.RowCount := StringGrid1.RowCount + 1;
end;

procedure TadxOlForm1.WndProc(var Message: TMessage);
begin
  if Message.Msg = WM_USER + 2500 then
    AddRow()
  else
    inherited WndProc(Message);
end;

initialization
  RegisterClass(TPersistentClass(TadxOlForm1));

finalization
end.
